from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String

Vep_Install_V0_1_0 = CommandToolBuilder(tool="vep_install", base_command=["vep_install"], inputs=[ToolInput(tag="in_destdir", input_type=Boolean(optional=True), prefix="--DESTDIR", doc=InputDocumentation(doc="Set destination directory for API install (default = './')")), ToolInput(tag="in_cache_version", input_type=Boolean(optional=True), prefix="--CACHE_VERSION", doc=InputDocumentation(doc="Set data (cache, FASTA) version to install if different from --VERSION (default = 103)")), ToolInput(tag="in_cache_dir", input_type=Boolean(optional=True), prefix="--CACHEDIR", doc=InputDocumentation(doc="Set destination directory for cache files (default = '/root/.vep/')")), ToolInput(tag="in_auto", input_type=Boolean(optional=True), prefix="--AUTO", doc=InputDocumentation(doc="Run installer without user prompts. Use 'a' (API + Faidx/htslib),\n'l' (Faidx/htslib only), 'c' (cache), 'f' (FASTA), 'p' (plugins) to specify\nparts to install e.g. -a ac for API and cache")), ToolInput(tag="in_no_update", input_type=Boolean(optional=True), prefix="--NO_UPDATE", doc=InputDocumentation(doc="Do not check for updates to ensembl-vep")), ToolInput(tag="in_species", input_type=Boolean(optional=True), prefix="--SPECIES", doc=InputDocumentation(doc="Comma-separated list of species to install when using --AUTO")), ToolInput(tag="in_assembly", input_type=Boolean(optional=True), prefix="--ASSEMBLY", doc=InputDocumentation(doc="Assembly name to use if more than one during --AUTO")), ToolInput(tag="in_plugins", input_type=Boolean(optional=True), prefix="--PLUGINS", doc=InputDocumentation(doc="Comma-separated list of plugins to install when using --AUTO")), ToolInput(tag="in_plugins_dir", input_type=Boolean(optional=True), prefix="--PLUGINSDIR", doc=InputDocumentation(doc="Set destination directory for VEP plugins files (default = '/root/.vep/Plugins/')")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--QUIET", doc=InputDocumentation(doc="Don't write any status output when using --AUTO")), ToolInput(tag="in_prefer_bin", input_type=Boolean(optional=True), prefix="--PREFER_BIN", doc=InputDocumentation(doc="Use this if the installer fails with out of memory errors")), ToolInput(tag="in_no_hts_lib", input_type=Boolean(optional=True), prefix="--NO_HTSLIB", doc=InputDocumentation(doc="Don't attempt to install Faidx/htslib")), ToolInput(tag="in_no_bioperl", input_type=Boolean(optional=True), prefix="--NO_BIOPERL", doc=InputDocumentation(doc="Don't install BioPerl")), ToolInput(tag="in_convert", input_type=Boolean(optional=True), prefix="--CONVERT", doc=InputDocumentation(doc="Convert downloaded caches to use tabix for retrieving\nco-located variants (requires tabix)")), ToolInput(tag="in_cache_url", input_type=Boolean(optional=True), prefix="--CACHEURL", doc=InputDocumentation(doc="Override default cache URL; this may be a local directory or\na remote (e.g. FTP) address.")), ToolInput(tag="in_fasta_url", input_type=Boolean(optional=True), prefix="--FASTAURL", doc=InputDocumentation(doc="Override default FASTA URL; this may be a local directory or\na remote (e.g. FTP) address. The FASTA URL/directory must have\ngzipped FASTA files under the following structure:\n[species]/[dna]/\n")), ToolInput(tag="in_perl", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_install_do_tpl", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_arguments", input_type=String(optional=True), position=2, doc=InputDocumentation(doc=""))], outputs=[], container="quay.io/biocontainers/ensembl-vep:103.1--pl526hecda079_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Vep_Install_V0_1_0().translate("wdl")

